Index: trunk/LMDZ.TITAN/libf/phytitan/sources.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/sources.F	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/sources.F	(revision 175)
@@ -0,0 +1,237 @@
+         SUBROUTINE sources(ngrid,nlay,
+     $                      ptimestep,pz0,pu,pv,
+     $                      pplev,pzlay,pzlev,
+     $                      gaz1,gaz2,gaz3,
+     $                      ptsrf,solesp,reserv)
+
+c=======================================================================
+c     Calcul des flux aux interfaces pour les sources
+c     CH4 a la surface
+c     Production de C2H6 en haut du modele.
+c     Production de C2H2 en haut du modele.
+c     
+c     NOTE :
+c     Les gaz ont la tete en haut. 
+c     ils ne suivent pas la meme convention que muphys :
+c     (1 -> sol  / klev = haut du modele)
+c=======================================================================
+
+c-----------------------------------------------------------------------
+c   declarations:
+c   -------------
+
+         use dimphy
+         IMPLICIT NONE
+#include "dimensions.h"
+#include "microtab.h"
+#include "YOMCST.h"
+c
+c   arguments:
+c   ----------
+
+         INTEGER ngrid,nlay,nq,ihor
+         REAL ptimestep
+         REAL pplev(ngrid,nlay+1)
+         REAL pzlay(ngrid,nlay),pzlev(ngrid,nlay+1)
+         REAL pu(ngrid),pv(ngrid)
+         REAL gaz1(ngrid,nlay),gaz2(ngrid,nlay),gaz3(ngrid,nlay)
+         REAL ptsrf(ngrid)
+         REAL solesp(ngrid,klev+1,3)
+c
+c   local:
+c   ------
+ 
+         INTEGER ilev,ig,ilay,nlev,k,inch4,inc2h6
+
+         REAL zgz1(klon,klev),zgz2(klon,klev),zgz3(klon,klev)
+         REAL zcdv(klon),zu2,pz0
+         REAL xmair,gg,zrho,ws,ch,qch4,flux
+         REAL xmuair
+         REAL zmem,zmem2,zmem3
+         REAL prodc2h6,prodc2h2
+         real reserv(ngrid),restemp,drestemp
+         REAL evapch4
+
+         real umin
+         data umin/1.e-12/
+         save umin
+
+c
+c-----------------------------------------------------------------------
+c   initialisations:
+c   -----------------
+
+         nlev=nlay+1
+
+         if(nlay.ne.klev) THEN
+           PRINT*,'STOP dans sources.F'
+           PRINT*,'probleme de dimensions :'
+           PRINT*,'nlay  =',nlay
+           PRINT*,'klev  =',klev
+           STOP
+         endif
+
+         IF(ngrid.NE.klon) THEN
+           PRINT*,'STOP dans sources.F'
+           PRINT*,'probleme de dimensions :'
+           PRINT*,'ngrid  =',ngrid
+           PRINT*,'klon  =',klon
+           STOP
+         ENDIF
+
+         zgz1 = gaz1
+         zgz2 = gaz2
+         zgz3 = gaz3
+
+c-----------------------------------------------------------------------
+c     2. calcul de  cd :
+c     ----------------
+c
+         DO ig=1,ngrid
+           zu2=pu(ig)*pu(ig)+pv(ig)*pv(ig)+umin
+           zcdv(ig)=pz0*(1.+sqrt(zu2))
+c           write(99,'(I4,3(ES24.17,1X))') ig,
+c     &     pz0,zu2,(1.+sqrt(zu2))
+         ENDDO
+c          write(99,*) ""
+
+c-----------------------------------------------------------------------
+c    4. Conditions aux limites pour CH4 et C2H6
+c    -------------------------------------------
+c
+
+*   Conditions CH4
+         DO ig=1,ngrid
+           evapch4=0.
+           restemp=0.
+           gg=RG*RA**2/(RA+pzlay(ig,1))**2.
+           zrho=(pplev(ig,1)-pplev(ig,2))/gg
+           zrho=zrho/(pzlev(ig,2)-pzlev(ig,1))
+           ws=sqrt(pu(ig)**2.+pv(ig)**2.)*(10./pzlay(ig,1))**0.2
+           ch=1.5*sqrt(zcdv(ig))
+c           write(100,'(I4,3(ES24.17,1X))')
+c     &     ig,sqrt(pu(ig)**2.+pv(ig)**2.),
+c     &     (10./pzlay(ig,1))**0.2,ws
+           call ch4sat(ptsrf(ig),pplev(ig,1),qch4) ! qch4=kg/kg
+           qch4=qch4*0.50 ! ici on impose 50% d'humidité au sol 
+        
+           if(reserv(ig).le. 1.e-10 ) then  
+             flux=0.
+             reserv(ig)=1.e-10
+           else
+             flux=zrho*ch*ws
+             flux=flux*0.1 ! fraction occupée par les lacs 
+           endif
+c           write(101,'(I4,5(ES24.17,1X))') 
+c     &     ig,reserv(ig),ws,ch,zrho,(pzlev(ig,1+1)-pzlev(ig,1))
+c           flux=flux/zrho/(pzlev(ig,1+1)-pzlev(ig,1)) ! dx/ds
+
+           zmem=zgz1(ig,1)
+           zgz1(ig,1)=(zgz1(ig,1)+flux*ptimestep*qch4*28./16.)
+     &                /(1.+flux*ptimestep)
+
+           gg=RG!*RA**2/(RA+pzlay(ig,1))**2.
+           xmair=(pplev(ig,1)-pplev(ig,1+1))/gg
+           xmair=xmair/(pzlev(ig,1+1)-pzlev(ig,1))
+           xmuair=28.!*(1.-zmem)+zmem*16.
+
+           drestemp = - (zgz1(ig,1)-zmem)*xmair ! en m3/m2=m
+     &     *(pzlev(ig,2)-pzlev(ig,1))*16./xmuair/425.
+
+c           ici on peut fixer un seuil sur drestemp 
+c           (ie limiter l'echange atm/surface)
+      
+           restemp=reserv(ig) +drestemp
+
+           IF (restemp.ge.0.) THEN 
+             reserv(ig) = reserv(ig) + drestemp
+             evapch4    = evapch4    + drestemp
+           ELSE
+*          Il n'y a pas suffisamment de méthane; on re-évalue le flux d'évaporation
+*          Quelle nouvelle concentration zgz1(ig,1) atteint-on en évaporant tout ?
+             zgz1(ig,1)=reserv(ig)/(xmair*(pzlev(ig,1+1)-pzlev(ig,1))
+     &                 *16./xmuair/425.)+zmem
+             evapch4=evapch4-reserv(ig)
+
+             if(reserv(ig).eq.0.) 
+     &       print*,'assechement du sol en ig=', ig,reserv(ig),flux
+
+             reserv(ig)=0.  ! on a tout évaporé...
+           ENDIF
+c         
+           solesp(ig,klev+1,1)=solesp(ig,klev+1,1)+evapch4  ! <0 si volume évaporé (m3/m2)
+
+c         write(498,'(I3,4(ES24.17,1X))') ig,gaz1(ig,1),zgz1(ig,1),flux
+         ENDDO
+c         write(498,*) "" 
+c         write(101,*) "" 
+*   Conditions C2H6
+
+         prodc2h6=6.e-12/5. ! kg/m2/s
+ 
+         IF (1.EQ.1) THEN
+           DO ig=1,ngrid
+             DO ilev=nlay,nlay-4,-1
+*            calcule de zrho (kg/m3) pour la couche...
+               gg=RG*RA**2/(RA+pzlay(ig,ilev))**2.
+               zrho=(pplev(ig,ilev)-pplev(ig,ilev+1))/gg
+               zrho=zrho/(pzlev(ig,ilev+1)-pzlev(ig,ilev))
+
+*              passage taux de production --> Dx_c2h6 a rajouter au niveau ilev
+               zmem2=zgz2(ig,ilev)
+               zgz2(ig,ilev)=zgz2(ig,ilev)+
+     &         prodc2h6*ptimestep/
+     &         abs(pzlev(ig,ilev+1)-pzlev(ig,ilev))    !  kg/m3/s
+     &         /zrho*28./30.
+
+             ENDDO
+           ENDDO
+
+         ELSE
+
+           DO ig=1,ngrid
+             DO ilev=nlay,nlay-8,-1
+               zgz2(ig,ilev)=1.2e-5
+             ENDDO
+           ENDDO
+
+         ENDIF  ! (fin 1.eq.0)
+
+*-------------------------------------
+*   Conditions C2H2
+
+         prodc2h2=1.6e-12/5. ! kg/m2/s
+
+         IF(1  .EQ.  1) THEN 
+
+           DO ig=1,ngrid
+             DO ilev=nlay,nlay-4,-1
+*            calcule de zrho (kg/m3) pour la couche...
+                gg=RG*RA**2/(RA+pzlay(ig,ilev))**2.
+                zrho=(pplev(ig,ilev)-pplev(ig,ilev+1))/gg
+                zrho=zrho/(pzlev(ig,ilev+1)-pzlev(ig,ilev))
+
+*            passage taux de production --> Dx_c2h2 a rajouter au niveau ilev
+                zmem3=zgz3(ig,ilev)
+                zgz3(ig,ilev)=zgz3(ig,ilev)+
+     &          (prodc2h2)*ptimestep/
+     &          abs(pzlev(ig,ilev+1)-pzlev(ig,ilev))  !  kg/m3/s
+     &          /zrho*28./26.
+
+             ENDDO
+
+           ENDDO
+
+         ENDIF
+
+c-----------------------------------------------------------------------
+         DO ig=1,ngrid
+           DO ilev=1,nlay
+             gaz1(ig,ilev)=zgz1(ig,ilev)
+             gaz2(ig,ilev)=zgz2(ig,ilev)
+             gaz3(ig,ilev)=zgz3(ig,ilev)
+           ENDDO
+         ENDDO
+
+        RETURN
+        END
Index: trunk/LMDZ.TITAN/libf/phytitan/varmuphy.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/varmuphy.h	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/varmuphy.h	(revision 175)
@@ -0,0 +1,36 @@
+!***********************************************************************
+! varmuphy.h : 
+! fichier contenant toutes les variables communes a la microphysique.
+! Necessite microtab.h (pour la definition de nrad).
+! NOTE : certaines variables restent spécifiques a seulement quelques 
+!        une des routines de la microphysique.  
+!***********************************************************************
+!***********************************************************************
+!             variables communes a tous les routines
+!***********************************************************************
+       real p(llm),t(llm),rho(llm),pb(llm+1),tb(llm+1),rhob(llm+1)
+       real ach4(llm),aar(llm),an2(llm) !var communes a brume.F et snuages.F
+       real z(llm),dz(llm),zb(llm+1),dzb(llm+1)
+       real v_e(nrad),r_e(nrad),vrat_e,dr_e(nrad),dv_e(nrad)
+
+       common/grille/z,zb,dz,dzb
+       common/donnees/p,pb,t,tb,rho,rhob,ach4,aar,an2
+       common/aergrid/v_e,r_e,vrat_e,dr_e,dv_e
+!***********************************************************************
+!             constantes communes a la microphysique.
+!***********************************************************************
+       real pi,                                                         &
+     &      nav,rgp,kbz,                                                &
+     &      rtit,g0,                                                    &
+     &      mch4,mc2h6,mc2h2,mar,mn2,mair,                              &
+     &      rhol,rhoi_ch4,rhoi_c2h6,rhoi_c2h2,                          &
+     &      mtetach4,mtetac2h6,mtetac2h2       
+   
+       common/phys/                                                     &
+     &      pi,                                                         &
+     &      nav,rgp,kbz,                                                &
+     &      rtit,g0,                                                    &
+     &      mch4,mc2h6,mc2h2,mar,mn2,mair,                              &
+     &      rhol,rhoi_ch4,rhoi_c2h6,rhoi_c2h2,                          &
+     &      mtetach4,mtetac2h6,mtetac2h2
+
Index: trunk/LMDZ.TITAN/libf/phytitan/write_histday.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/write_histday.h	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/write_histday.h	(revision 175)
@@ -94,19 +94,116 @@
      .                                   iim*jjmp1*klev,ndex3d)
 c
-      ENDIF !lev_histday.GE.2
-c
-c-------------------------------------------------------
-      IF(lev_histday.GE.3) THEN
-c
 cccccccccccccccccc  Tracers
 c
          if (iflag_trac.eq.1) THEN
-          if (microfi.eq.1) then
-           DO iq=1,nmicro
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qaer(1,1,iq), zx_tmp_3d)
-       CALL histwrite(nid_day,tname(iq),itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-           ENDDO
+          if (microfi.ge.1) then
+c           DO iq=1,nmicro
+c      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qaer(1,1,iq), zx_tmp_3d)
+c      CALL histwrite(nid_day,tname(iq),itau_w,zx_tmp_3d,
+c     .                                   iim*jjmp1*klev,ndex3d)
+c           ENDDO
+c    -------   NB AER TOT
+               do i=1,klon
+                 do j=1,klev
+                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,1:nrad))
+                 enddo
+               enddo
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_day,"qaer",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c    -------   NB NOY TOT
+               do i=1,klon
+                 do j=1,klev
+                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,nrad+1:2*nrad))
+                 enddo
+               enddo
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_day,"qnoy",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c    -------   V GLA1 TOT
+               do i=1,klon
+                 do j=1,klev
+                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,2*nrad+1:3*nrad))
+                 enddo
+               enddo
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_day,"qgl1",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c    -------   V GLA2 TOT
+               do i=1,klon
+                 do j=1,klev
+                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,3*nrad+1:4*nrad))
+                 enddo
+               enddo
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_day,"qgl2",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c    -------   V GLA3 TOT
+               do i=1,klon
+                 do j=1,klev
+                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,4*nrad+1:5*nrad))
+                 enddo
+               enddo
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+       CALL histwrite(nid_day,"qgl3",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c --------------
+c ----- SATURATION ESP NUAGES
+             if (clouds.eq.1) then
+
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satch4,zx_tmp_3d)
+       CALL histwrite(nid_day,"ch4sat", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h6,zx_tmp_3d)
+       CALL histwrite(nid_day,"c2h6sat", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h2,zx_tmp_3d)
+       CALL histwrite(nid_day,"c2h2sat", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c --------------
+c ----- RESERVOIR DE SURFACE
+       CALL gr_fi_ecrit(1, klon,iim,jjmp1,reservoir,zx_tmp_2d)
+       CALL histwrite(nid_day,"reserv",itau_w,zx_tmp_2d,
+     .                        iim*jjmp1,ndex2d)
+c --------------
+c ----- PRECIPITATIONS
+c       -----  CH4
+       CALL gr_fi_ecrit(1, klon,iim,jjmp1,prec(:,1),zx_tmp_2d)
+       CALL histwrite(nid_day,"prech4",itau_w,zx_tmp_2d,
+     .                        iim*jjmp1,ndex2d)
+c       -----  C2H6
+       CALL gr_fi_ecrit(1, klon,iim,jjmp1,prec(:,2),zx_tmp_2d)
+       CALL histwrite(nid_day,"prec2h6",itau_w,zx_tmp_2d,
+     .                        iim*jjmp1,ndex2d)
+c       -----  C2H2
+       CALL gr_fi_ecrit(1, klon,iim,jjmp1,prec(:,3),zx_tmp_2d)
+       CALL histwrite(nid_day,"prec2h2",itau_w,zx_tmp_2d,
+     .                        iim*jjmp1,ndex2d)
+c
+c --------------
+c ----- FLUX GLACE
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,flxesp_i(1,1,1),zx_tmp_3d)
+       CALL histwrite(nid_day,"flxgl1", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,flxesp_i(1,1,2),zx_tmp_3d)
+       CALL histwrite(nid_day,"flxgl2", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,flxesp_i(1,1,3),zx_tmp_3d)
+       CALL histwrite(nid_day,"flxgl3", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c
+c --------------
+c ----- RAYON MOYEN GOUTTE
+       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, rmcloud,zx_tmp_3d)
+       CALL histwrite(nid_day,"rcldbar", itau_w, zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c
+             endif
 	  endif
+c
+c --------------
+c ----- TRACEURS CHIMIQUES
 	  if (nmicro.lt.nqmax) then
            DO iq=nmicro+1,nqmax
@@ -118,4 +215,9 @@
          endif
 c
+      ENDIF !lev_histday.GE.2
+c
+c-------------------------------------------------------
+      IF(lev_histday.GE.3) THEN
+c
 cccccccccccccccccc  Radiative transfer
 c
@@ -143,6 +245,6 @@
      .                                   iim*jjmp1*klev,ndex3d)
 c
-c 3D adding Tau and k  (31/08/10)
-c 
+c --------------
+c ----- OPACITE BRUME
        do k=7,NSPECV,10
          do i=1,klon
@@ -158,13 +260,27 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+           t_tauhvd(i,l)=TAUHID(i,klev-l+1,k)
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_day,"thi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c
+c --------------
+c ----- EXTINCTION BRUME
        do k=7,NSPECV,10
          do i=1,klon
          do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
-     s    -TAUHVD(i,klev-l+1-1,k)
-
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
+     s                -TAUHVD(i,klev-l+1-1,k)
           if(l.eq.klev)
-     s    t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
+     s     t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
 
          t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
@@ -178,4 +294,25 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUHID(i,klev-l+1,k)
+     s                -TAUHID(i,klev-l+1-1,k)
+          if(l.eq.klev)
+     s     t_khvd(i,l)=TAUHID(i,klev-l+1,k)
+
+         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_day,"khi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c
+c --------------
+c ----- OPACITE GAZ
        do k=7,NSPECV,10
          do i=1,klon
@@ -191,13 +328,27 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+           t_tauhvd(i,l)=TAUGID(i,klev-l+1,k)
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_day,"tgi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c
+c --------------
+c ----- EXTINCTION GAZ
        do k=7,NSPECV,10
          do i=1,klon
          do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
-     s    -TAUGVD(i,klev-l+1-1,k)
-
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
+     s                -TAUGVD(i,klev-l+1-1,k)
           if(l.eq.klev)
-     s    t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
+     s     t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
 
          t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
@@ -214,67 +365,44 @@
          do i=1,klon
          do l=1,klev
-           t_tauhvd(i,l)=TAUHID(i,klev-l+1,k)
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"thi"//str1,itau_w,zx_tmp_3d,
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUGID(i,klev-l+1,k)
+     s                -TAUGID(i,klev-l+1-1,k)
+
+          if(l.eq.klev)
+     s     t_khvd(i,l)=TAUGID(i,klev-l+1,k)
+
+         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_day,"kgi"//str1,itau_w,zx_tmp_3d,
      .                                   iim*jjmp1*klev,ndex3d)
        enddo      ! fin boucle NSPECI 
 
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUHID(i,klev-l+1,k)
-     s    -TAUHID(i,klev-l+1-1,k)
-
-          if(l.eq.klev)
-     s    t_khvd(i,l)=TAUHID(i,klev-l+1,k)
-
-         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"khi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-           t_tauhvd(i,l)=TAUGID(i,klev-l+1,k)
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"tgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUGID(i,klev-l+1,k)
-     s    -TAUGID(i,klev-l+1-1,k)
-
-          if(l.eq.klev)
-     s    t_khvd(i,l)=TAUGID(i,klev-l+1,k)
-
-         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"kgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
+c --------------
+c ----- OPACITE NUAGES (ATTENTION PROXY)
+         if (clouds.eq.1) then
+           zx_tmp_fi3d(1:klon,1:klev)=occcld(1:klon,1:klev)
+           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+           CALL histwrite(nid_day,"tcld",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+c --------------
+c ----- EXTINCTION NUAGES (ATTENTION PROXY)
+           do i=1,klon
+             t_kcld(i,klev)=occcld(i,klev)
+     .       /(zzlev(i,klev+1)-zzlev(i,klev))
+             do j=klev-1,1,-1
+               t_kcld(i,j)=(occcld(i,j)-occcld(i,j+1))
+     .         /(zzlev(i,j+1)-zzlev(i,j))
+             enddo
+           enddo
+           zx_tmp_fi3d(1:klon,1:klev)=t_kcld(1:klon,1:klev)
+           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+           CALL histwrite(nid_day,"kcld",itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+        endif  
+c
       ENDIF !lev_histday.GE.3
 c
Index: trunk/LMDZ.TITAN/libf/phytitan/write_histins.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/write_histins.h	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/write_histins.h	(revision 175)
@@ -143,6 +143,6 @@
      .                                   iim*jjmp1*klev,ndex3d)
 c
-c 3D adding Tau and k  (31/08/10)
-c 
+c --------------
+c ----- OPACITE BRUME
        do k=7,NSPECV,10
          do i=1,klon
@@ -158,13 +158,27 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+           t_tauhvd(i,l)=TAUHID(i,klev-l+1,k)
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_ins,"thi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c --------------
+c ----- EXTINCTION BRUME
        do k=7,NSPECV,10
          do i=1,klon
          do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
-     s    -TAUHVD(i,klev-l+1-1,k)
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
+     s                -TAUHVD(i,klev-l+1-1,k)
 
           if(l.eq.klev)
-     s    t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
+     s     t_khvd(i,l)=TAUHVD(i,klev-l+1,k)
 
          t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
@@ -178,4 +192,25 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUHID(i,klev-l+1,k)
+     s                -TAUHID(i,klev-l+1-1,k)
+
+          if(l.eq.klev)
+     s     t_khvd(i,l)=TAUHID(i,klev-l+1,k)
+
+         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_ins,"khi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c --------------
+c ----- OPACITE GAZ
        do k=7,NSPECV,10
          do i=1,klon
@@ -191,13 +226,27 @@
        enddo      ! fin boucle NSPECV 
 
+       do k=8,NSPECI,10
+         do i=1,klon
+         do l=1,klev
+           t_tauhvd(i,l)=TAUGID(i,klev-l+1,k)
+         enddo
+         enddo
+         write(str1,'(i2.2)') k
+      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
+      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
+      CALL histwrite(nid_ins,"tgi"//str1,itau_w,zx_tmp_3d,
+     .                                   iim*jjmp1*klev,ndex3d)
+       enddo      ! fin boucle NSPECI 
+c --------------
+c ----- EXTINCTION GAZ
        do k=7,NSPECV,10
          do i=1,klon
          do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
-     s    -TAUGVD(i,klev-l+1-1,k)
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
+     s                -TAUGVD(i,klev-l+1-1,k)
 
           if(l.eq.klev)
-     s    t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
+     s     t_khvd(i,l)=TAUGVD(i,klev-l+1,k)
 
          t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
@@ -214,56 +263,10 @@
          do i=1,klon
          do l=1,klev
-           t_tauhvd(i,l)=TAUHID(i,klev-l+1,k)
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"thi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUHID(i,klev-l+1,k)
-     s    -TAUHID(i,klev-l+1-1,k)
+          if(l.ne.klev)
+     s     t_khvd(i,l)=TAUGID(i,klev-l+1,k)
+     s                -TAUGID(i,klev-l+1-1,k)
 
           if(l.eq.klev)
-     s    t_khvd(i,l)=TAUHID(i,klev-l+1,k)
-
-         t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"khi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-           t_tauhvd(i,l)=TAUGID(i,klev-l+1,k)
-         enddo
-         enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"tgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-       enddo      ! fin boucle NSPECI 
-
-       do k=8,NSPECI,10
-         do i=1,klon
-         do l=1,klev
-         if(l.ne.klev)
-     s    t_khvd(i,l)=TAUGID(i,klev-l+1,k)
-     s    -TAUGID(i,klev-l+1-1,k)
-
-          if(l.eq.klev)
-     s    t_khvd(i,l)=TAUGID(i,klev-l+1,k)
+     s     t_khvd(i,l)=TAUGID(i,klev-l+1,k)
 
          t_khvd(i,l)=t_khvd(i,l)/(zzlev(i,l+1)-zzlev(i,l))
